
#include <tiny13a.h>
#include <stdint.h>
#include <delay.h>

#define ADC_VREF_TYPE ((0<<REFS0) | (0<<ADLAR))
uint8_t status = 0;
/*uint8_t speed = 0;
uint8_t chanel = 0;
uint8_t delay = 0;
uint16_t time = 0; */
uint32_t temp = 0;   
uint8_t lm = 23;
__eeprom uint8_t eepromDT;
// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | ADC_VREF_TYPE;
delay_us(10);
ADCSRA|=(1<<ADSC);
while ((ADCSRA & (1<<ADIF))==0);
ADCSRA|=(1<<ADIF);
return ADCW;
}



void main(void)
{
   // uint32_t temp = 0;  
    uint32_t volt = 0;
    
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=(1<<CLKPCE);
CLKPR=(0<<CLKPCE) | (0<<CLKPS3) | (0<<CLKPS2) | (0<<CLKPS1) | (0<<CLKPS0);
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Function: Bit5=In Bit4=In Bit3=In Bit2=In Bit1=Out Bit0=Out 
DDRB=(0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (0<<DDB2) | (1<<DDB1) | (0<<DDB0);
// State: Bit5=T Bit4=T Bit3=T Bit2=T Bit1=0 Bit0=0 
PORTB=(0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 9600,000 kHz
// Mode: Fast PWM top=0xFF
// OC0A output: Non-Inverted PWM
// OC0B output: Non-Inverted PWM
// Timer Period: 0,026667 ms
// Output Pulse(s):
// OC0A Period: 0,026667 ms Width: 0 us// OC0B Period: 0,026667 ms Width: 0 us

/*TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (0<<COM0B1) | (0<<COM0B0) | (1<<WGM01) | (1<<WGM00); 
TCCR0B=(0<<WGM02) | (0<<CS02) | (0<<CS01) | (1<<CS00);     */

//TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (1<<COM0B1) | (0<<COM0B0) | (1<<WGM01) | (1<<WGM00);
TCCR0B=(0<<WGM02) | (0<<CS02) | (1<<CS01) | (1<<CS00);   

TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=(0<<OCIE0B) | (0<<OCIE0A) | (0<<TOIE0);

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=(0<<INT0) | (0<<PCIE);
MCUCR=(0<<ISC01) | (0<<ISC00);

// Analog Comparator initialization
// Analog Comparator: Off
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIS1) | (0<<ACIS0);
// Digital input buffer on AIN0: On
// Digital input buffer on AIN1: On
DIDR0=(0<<AIN0D) | (0<<AIN1D);

// ADC initialization
// ADC Clock frequency: 600,000 kHz
// ADC Bandgap Voltage Reference: Off
// ADC Auto Trigger Source: ADC Stopped
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
DIDR0|=(0<<ADC0D) | (0<<ADC2D) | (0<<ADC3D) | (0<<ADC1D);
ADMUX=ADC_VREF_TYPE;
ADCSRA=(1<<ADEN) | (0<<ADSC) | (0<<ADATE) | (0<<ADIF) | (0<<ADIE) | (1<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
ADCSRB=(0<<ADTS2) | (0<<ADTS1) | (0<<ADTS0);
    lm=eepromDT;   
    if(lm>125)lm=0;  
 //temp = read_adc(1); 
while (1)
      { 

        //temp = read_adc(1);    
       
        if(PINB.4 && !PINB.3 && !status && lm>0){  ///    
            delay_ms(250); 
            if(PINB.4 && !PINB.3){  ///     
                delay_ms(250);    
                if(PINB.4 && !PINB.3){   
                    delay_ms(250);
                    if(PINB.4 && !PINB.3){  
                        delay_ms(300);
                        if(PINB.4 && !PINB.3){
                            delay_ms(1000);   
                            TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (1<<COM0B1) | (0<<COM0B0) | (1<<WGM01) | (1<<WGM00);
                            status=1;  
                            OCR0B=lm;   
                        }
                    }      
                }
            }   
        }          
        else if(!PINB.4 || PINB.3 || !lm){     
            delay_ms(50);  
            if(!PINB.4 || PINB.3){
                OCR0B=0;  
                TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (0<<COM0B1) | (0<<COM0B0) | (1<<WGM01) | (1<<WGM00);    
                status=0;     
            }
        }
        if(!PINB.0){  
            delay_ms(70);    
            if(!PINB.0){ 
                lm+=25;   
                if(lm>125)lm=0; 
                OCR0B=lm;   
                while(!PINB.0); 
                eepromDT=lm;
            }
        }
        delay_ms(30);
      }
      
}
